// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from cob_msgs:msg/EmergencyStopState.idl
// generated code does not contain a copyright notice

#include "cob_msgs/msg/detail/emergency_stop_state__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_cob_msgs
const rosidl_type_hash_t *
cob_msgs__msg__EmergencyStopState__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x32, 0x30, 0xe4, 0xef, 0x6a, 0x15, 0x40, 0x6a,
      0x22, 0x4d, 0xfe, 0x47, 0xd1, 0xda, 0xb8, 0x5c,
      0x61, 0xca, 0xa0, 0xe1, 0x17, 0x29, 0x4e, 0xb0,
      0xe1, 0xa6, 0xd9, 0x27, 0xc2, 0xec, 0xa7, 0xdc,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char cob_msgs__msg__EmergencyStopState__TYPE_NAME[] = "cob_msgs/msg/EmergencyStopState";

// Define type names, field names, and default values
static char cob_msgs__msg__EmergencyStopState__FIELD_NAME__emergency_button_stop[] = "emergency_button_stop";
static char cob_msgs__msg__EmergencyStopState__FIELD_NAME__scanner_stop[] = "scanner_stop";
static char cob_msgs__msg__EmergencyStopState__FIELD_NAME__monitoring_stop[] = "monitoring_stop";
static char cob_msgs__msg__EmergencyStopState__FIELD_NAME__user_interaction_stop[] = "user_interaction_stop";
static char cob_msgs__msg__EmergencyStopState__FIELD_NAME__hardware_stop[] = "hardware_stop";
static char cob_msgs__msg__EmergencyStopState__FIELD_NAME__bumper_stop[] = "bumper_stop";
static char cob_msgs__msg__EmergencyStopState__FIELD_NAME__fall_stop[] = "fall_stop";
static char cob_msgs__msg__EmergencyStopState__FIELD_NAME__charge_stop[] = "charge_stop";
static char cob_msgs__msg__EmergencyStopState__FIELD_NAME__emergency_state[] = "emergency_state";

static rosidl_runtime_c__type_description__Field cob_msgs__msg__EmergencyStopState__FIELDS[] = {
  {
    {cob_msgs__msg__EmergencyStopState__FIELD_NAME__emergency_button_stop, 21, 21},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_BOOLEAN,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {cob_msgs__msg__EmergencyStopState__FIELD_NAME__scanner_stop, 12, 12},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_BOOLEAN,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {cob_msgs__msg__EmergencyStopState__FIELD_NAME__monitoring_stop, 15, 15},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_BOOLEAN,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {cob_msgs__msg__EmergencyStopState__FIELD_NAME__user_interaction_stop, 21, 21},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_BOOLEAN,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {cob_msgs__msg__EmergencyStopState__FIELD_NAME__hardware_stop, 13, 13},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_BOOLEAN,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {cob_msgs__msg__EmergencyStopState__FIELD_NAME__bumper_stop, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_BOOLEAN,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {cob_msgs__msg__EmergencyStopState__FIELD_NAME__fall_stop, 9, 9},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_BOOLEAN,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {cob_msgs__msg__EmergencyStopState__FIELD_NAME__charge_stop, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_BOOLEAN,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {cob_msgs__msg__EmergencyStopState__FIELD_NAME__emergency_state, 15, 15},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
cob_msgs__msg__EmergencyStopState__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {cob_msgs__msg__EmergencyStopState__TYPE_NAME, 31, 31},
      {cob_msgs__msg__EmergencyStopState__FIELDS, 9, 9},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# This message holds the emergency stop (EMStop) status of the robot. It detects wether an EMStop is caused by the safety laserscanner or the emergency stop buttons. Moreover, it gives signalizes wether the EMStop was confirmed (after Button press stop) and the system is free again.\n"
  "\n"
  "# Possible EMStop States\n"
  "int16 EMFREE = 0            # system operatign normal\n"
  "int16 EMSTOP = 1            # emergency stop is active (Button pressed; obstacle in safety field of scanner)\n"
  "int16 EMCONFIRMED = 2       # emergency stop was confirmed system is reinitializing and going back to normal\n"
  "\n"
  "bool emergency_button_stop  # true = emergency stop signal is issued by button pressed\n"
  "bool scanner_stop           # true = emergency stop signal is issued by scanner\n"
  "bool monitoring_stop        # true = emergency stop signal is issued by monitor\n"
  "bool user_interaction_stop  # true = emergency stop signal is issued by ui\n"
  "bool hardware_stop          # true = emergency stop signal is issued due to hardware failure \n"
  "bool bumper_stop            # true = emergency stop signal is issued by bumper\n"
  "bool fall_stop              # true = emergency stop signal is issued by fall-protecting sensors\n"
  "bool charge_stop            # true = emergency stop signal is issued due to charging process\n"
  "\n"
  "int16 emergency_state       # state (including confimation by key-switch), values see above";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
cob_msgs__msg__EmergencyStopState__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {cob_msgs__msg__EmergencyStopState__TYPE_NAME, 31, 31},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 1359, 1359},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
cob_msgs__msg__EmergencyStopState__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *cob_msgs__msg__EmergencyStopState__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
